// applic.h
#if !defined(__APPLIC_H)
#define __APPLIC_H

class CAppWindow
{
public:
	CAppWindow(PSTR szName="AppWindow");
	virtual ~CAppWindow();
	HWND GetHandle() { return hWnd; }
	int Run();
	long MsgProc(UINT lMessage, UINT sParam, LONG lParam);
	int SetPalette(BOOL bForceBkgnd);
	void Destroy();
	void Invalidate(BOOL Flag = TRUE);

protected:
	HWND hWnd;
	PSTR Name;
	HPALETTE hpal;
	int Width, Height;

	void Create();
	
	// User-defined operations
	virtual void SetupWindow() { }
	virtual void Paint(HDC hdc) { }
	virtual void CleanupWindow() { }
	virtual void WmCommand(UINT wParam, LONG lParam) { }
	virtual void WmDrawItem(UINT wParam, LONG lParam) { }
	virtual void WmKeyDown(UINT wParam, LONG lParam) { }
	virtual void WmChar(UINT wParam, LONG lParam) { }
	virtual void WmMouseMove(int modkeys, POINT pt) { }
	virtual void WmLButtonDown(POINT pt) { }
	virtual void WmLButtonUp(POINT pt) {  }
	virtual void WmRButtonDown(POINT pt) { }
	virtual void WmRButtonUp(POINT pt) {  }
	virtual void WmSetFocus() { }
	virtual void WmKillFocus() { }
	virtual void WmSize(int width, int height) { }
	virtual void WmTimer() { }
	virtual void WmVScroll(UINT wParam, LONG lParam) { }
};

HINSTANCE GetInstance();
PSTR GetCmdLine();

inline void MoveTo(HDC hdc, int x, int y)
{
	MoveToEx(hdc,x,y,0);
}

#endif
