/* wsquares.cpp
*
*   Draw collapsing pattern of squares
*
*/
#include <stdio.h>
#include <math.h>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "applic.h"

class MyApp: public CAppWindow
{
public:
	MyApp(char *name);
	void Paint(HDC hdc);
};

MyApp::MyApp(char *name): CAppWindow(name)
{
	Width  = 380;
	Height = 380;
}

void MyApp::Paint(HDC hdc)
{
	int i, j, k;
	double x[4], y[4], xtemp[4], ytemp[4], p, q;
	p =  0.9;   q = 1.0 - p;
	x[0] = 40;  y[0] = 40;     x[1] = 340; y[1] =  40;
	x[2] = 340;  y[2] =340;     x[3] = 40; y[3] = 340;
	for (i=0; i<25; i++) {
		MoveTo(hdc,(int)x[3],(int)y[3]);
		for (j=0; j<4; j++ ) {
			LineTo(hdc,(int)x[j],(int)y[j]);
			xtemp[j] = x[j];  ytemp[j] = y[j];
		}
		for (j=0; j<4; j++) {
			k = (j+1) % 4;
			x[j] = p*xtemp[j] + q*xtemp[k];
			y[j] = p*ytemp[j] + q*ytemp[k];
		}
	}
}


int Main()
{
	return MyApp("Squares").Run();
}
